﻿#include <Windows.h>
#include <stdio.h>

#define SYMLINK_NAME L"\\\\.\\ILDriver"
#define IOCTL_SET_PROCESS_NAME CTL_CODE(FILE_DEVICE_UNKNOWN, 0x801, METHOD_BUFFERED, FILE_ANY_ACCESS)

int wmain(int argc, wchar_t *argv[], wchar_t *envp[])
{
	HANDLE DrvHandle;
	DWORD Size;
	WCHAR In[MAX_PATH];
	BOOLEAN Out;


	if (argc != 2)
	{
		printf("Usage: %ls program_name.exe\n", argv[0]);
		return -1;
	}

	wcscpy_s(In, sizeof(In) / sizeof(WCHAR), argv[1]);
	
	DrvHandle = CreateFile
	(
		SYMLINK_NAME,
		GENERIC_READ | GENERIC_WRITE,
		FILE_SHARE_READ | FILE_SHARE_WRITE,
		NULL,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,
		0
	);

	if (DrvHandle == INVALID_HANDLE_VALUE)
	{
		printf("Can't open handle\n");
		return -1;
	}
	
	if
	(
		!DeviceIoControl
		(
			DrvHandle,
			IOCTL_SET_PROCESS_NAME,
			&In,
			sizeof(In),
			&Out,
			sizeof(BOOLEAN),
			&Size,
			NULL
		)
	)
	{
		CloseHandle(DrvHandle);
		printf("DeviceIoControl failed\n");
		return -1;
	}
	
	printf("DeviceIoControl: %d\n", Out);
	CloseHandle(DrvHandle);

	Sleep(1000);

	return 0;
}
